#pragma once

#include "standardglobe_global.h"

class QVector3D;

/// <summary>
/// γ
/// </summary>
struct LonLatPos {
	double _lon_deg = 0;
	double _lat_deg = 0;
};

/// <summary>
/// γϵ
/// </summary>
struct LonLatAltPos {
	double _lon_deg = 0;
	double _lat_deg = 0;
	double _alt_m = 0;
};

/// <summary>
/// ϵ
/// </summary>
struct ECEFPos {
	double _x_pos = 0;// ָ0㾭Ȧγ0㽻
	double _y_pos = 0;
	double _z_pos = 0;
	QVector3D getVec3() const;
	static ECEFPos fromVec3(const QVector3D& p);
};

/// <summary>
/// 챱ϵ
/// </summary>
struct ENUPos {
	double _e_pos = 0;
	double _n_pos = 0;
	double _t_pos = 0;
};

/// <summary>
/// 
/// </summary>
struct PolarPos {
	double _dist_m = 0;
	double _azimuth_deg = 0;
	double _pitch_deg = 0;
};

/// <summary>
/// ׼ת
/// </summary>
class STANDARDGLOBE_EXPORT StandardGlobe
{
private:
	/// <summary>
	/// ׼ֱ
	/// </summary>
	static double _radius_m;

public:
	StandardGlobe();

	static ECEFPos llaToEcef(const LonLatAltPos &v);
	static LonLatAltPos ecefToLLA(const ECEFPos &v);
	/// <summary>
	/// LLAȡ֮Ĵ߳Ⱥb->tʼλǣwarningLLAĸ߶ֵ
	/// </summary>
	/// <param name="base"></param>
	/// <param name="target"></param>
	/// <param name="dist"></param>
	/// <param name="azi"></param>
	static void getDistanceWithTargetLLA(const LonLatAltPos &base, const LonLatAltPos &target, double &dist, double &azi);
	/// <summary>
	/// ֮Ĵ߳Ⱥb->tʼλǣĿLLAλ
	/// </summary>
	/// <param name="base"></param>
	/// <param name="dist"></param>
	/// <param name="azi"></param>
	/// <param name="target"></param>
	static void getTargetLLAWithDistance(const LonLatAltPos& base, double dist, double azi, LonLatAltPos& target);
	/// <summary>
	/// ͨLLA꣬ȡĿ꼫
	/// </summary>
	/// <param name="base"></param>
	/// <param name="target"></param>
	/// <returns></returns>
	static PolarPos getPolarWithLLA(const LonLatAltPos &base, const LonLatAltPos &target);
	/// <summary>
	/// ͨ꣬ȡĿLLA
	/// </summary>
	/// <param name="base"></param>
	/// <param name="target"></param>
	/// <returns></returns>
	static LonLatAltPos getLLAWithPolar(const LonLatAltPos &base, const PolarPos &target);
};
